- Main Page
- Namespaces
- Classes
- Files

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# Ipopt::Ma57TSolverInterface Class Reference

Interface to the symmetric linear solver MA57, derived from SparseSymLinearSolverInterface. More...

`#include <IpMa57TSolverInterface.hpp>`

Inheritance diagram for Ipopt::Ma57TSolverInterface:

[legend]
Collaboration diagram for Ipopt::Ma57TSolverInterface:

[legend]
List of all members.

## Public Member Functions
bool | InitializeImpl (const OptionsList &options, const std::string &prefix)
| overloaded from AlgorithmStrategyObject
Constructor/Destructor
| Ma57TSolverInterface ()
| Constructor.
virtual | ~Ma57TSolverInterface ()
| Destructor.
Methods for requesting solution of the linear system.
virtual ESymSolverStatus | InitializeStructure (Index dim, Index nonzeros, const Index *airn, const Index *ajcn)
| Method for initializing internal stuctures.
virtual double * | GetValuesArrayPtr ()
| Method returing an internal array into which the nonzero elements (in the same order as airn and ajcn) are to be stored by the calling routine before a call to MultiSolve with a new_matrix=true.
virtual ESymSolverStatus | MultiSolve (bool new_matrix, const Index *airn, const Index *ajcn, Index nrhs, double *rhs_vals, bool check_NegEVals, Index numberOfNegEVals)
| Solve operation for multiple right hand sides.
virtual Index | NumberOfNegEVals () const
| Number of negative eigenvalues detected during last factorization.
virtual bool | IncreaseQuality ()
| Request to increase quality of solution for next solve.
virtual bool | ProvidesInertia () const
| Query whether inertia is computed by linear solver.
EMatrixFormat | MatrixFormat () const
| Query of requested matrix type that the linear solver understands.
## Static Public Member Functions
static void | RegisterOptions (SmartPtr< RegisteredOptions > roptions)
| Methods for IpoptType.
## Private Member Functions
Default Compiler Generated Methods
(Hidden to avoid implicit creation/calling). These methods are not implemented and we do not want the compiler to implement them for us, so we declare them private and do not define them. This ensures that they will not be implicitly created/called.
| Ma57TSolverInterface (const Ma57TSolverInterface &)
| Copy Constructor.
void | operator= (const Ma57TSolverInterface &)
| Overloaded Equals Operator.
Internal functions
ESymSolverStatus | SymbolicFactorization (const Index *airn, const Index *ajcn)
| Call MA57AD and reserve memory for MA57 data.
ESymSolverStatus | Factorization (const Index *airn, const Index *ajcn, bool check_NegEVals, Index numberOfNegEVals)
| Call MA57BD to factorize the Matrix.
ESymSolverStatus | Backsolve (Index nrhs, double *rhs_vals)
| Call MA57CD to do the backsolve.
## Private Attributes
Information about the matrix
Index | dim_
| Number of rows and columns of the matrix.
Index | nonzeros_
| Number of nonzeros of the matrix.
Information about most recent factorization/solve
Index | negevals_
| Number of negative eigenvalues.
Initialization flags
bool | initialized_
| Flag indicating if internal data is initialized.
bool | pivtol_changed_
| Flag indicating if the matrix has to be refactorized because the pivot tolerance has been changed.
bool | refactorize_
| Flag that is true if we just requested the values of the matrix again (SYMSOLVER_CALL_AGAIN) and have to factorize again.
Solver specific data/options
Number | pivtol_
| Pivol tolerance.
Number | pivtolmax_
| Maximal pivot tolerance.
Number | ma57_pre_alloc_
| Factor for estimating initial size of work arrays.
bool | warm_start_same_structure_
| Flag indicating whether the TNLP with identical structure has already been solved before.
Data for the linear solver.
Storing factorization and other solver specific data structure.
double | wd_cntl_ [5]
ipfint | wd_icntl_ [20]
ipfint | wd_info_ [40]
double | wd_rinfo_ [20]
ipfint | wd_lkeep_
ipfint * | wd_keep_
ipfint * | wd_iwork_
double * | wd_fact_
ipfint | wd_lfact_
ipfint * | wd_ifact_
ipfint | wd_lifact_
double * | a_
| factor A of matrix

## Detailed Description

Interface to the symmetric linear solver MA57, derived from SparseSymLinearSolverInterface.

Definition at line 20 of file IpMa57TSolverInterface.hpp.

## Constructor & Destructor Documentation

Ipopt::Ma57TSolverInterface::Ma57TSolverInterface | ( |  | ) |

Constructor.

virtual Ipopt::Ma57TSolverInterface::~Ma57TSolverInterface | ( |  | ) | `[virtual]`

Destructor.

Ipopt::Ma57TSolverInterface::Ma57TSolverInterface | ( | const Ma57TSolverInterface & |  | ) | `[private]`

Copy Constructor.

## Member Function Documentation

bool Ipopt::Ma57TSolverInterface::InitializeImpl | ( | const OptionsList & | options,
|  | const std::string & | prefix |
| ) |  |  | `[virtual]`

overloaded from AlgorithmStrategyObject

Implements Ipopt::SparseSymLinearSolverInterface.

virtual ESymSolverStatus Ipopt::Ma57TSolverInterface::InitializeStructure | ( | Index | dim,
|  | Index | nonzeros,
|  | const Index * | airn,
|  | const Index * | ajcn |
| ) |  |  | `[virtual]`

Method for initializing internal stuctures.

Here, ndim gives the number of rows and columns of the matrix, nonzeros give the number of nonzero elements, and airn and acjn give the positions of the nonzero elements.

Implements Ipopt::SparseSymLinearSolverInterface.

virtual double* Ipopt::Ma57TSolverInterface::GetValuesArrayPtr | ( |  | ) | `[virtual]`

Method returing an internal array into which the nonzero elements (in the same order as airn and ajcn) are to be stored by the calling routine before a call to MultiSolve with a new_matrix=true.

The returned array must have space for at least nonzero elements.

Implements Ipopt::SparseSymLinearSolverInterface.

virtual ESymSolverStatus Ipopt::Ma57TSolverInterface::MultiSolve | ( | bool | new_matrix,
|  | const Index * | airn,
|  | const Index * | ajcn,
|  | Index | nrhs,
|  | double * | rhs_vals,
|  | bool | check_NegEVals,
|  | Index | numberOfNegEVals |
| ) |  |  | `[virtual]`

Solve operation for multiple right hand sides.

Overloaded from SparseSymLinearSolverInterface.

Implements Ipopt::SparseSymLinearSolverInterface.

virtual Index Ipopt::Ma57TSolverInterface::NumberOfNegEVals | ( |  | ) | const`[virtual]`

Number of negative eigenvalues detected during last factorization.

Returns the number of negative eigenvalues of the most recent factorized matrix. This must not be called if the linear solver does not compute this quantities (see ProvidesInertia).

Implements Ipopt::SparseSymLinearSolverInterface.

virtual bool Ipopt::Ma57TSolverInterface::IncreaseQuality | ( |  | ) | `[virtual]`

Request to increase quality of solution for next solve.

Ask linear solver to increase quality of solution for the next solve (e.g. increase pivot tolerance). Returns false, if this is not possible (e.g. maximal pivot tolerance already used.)

Implements Ipopt::SparseSymLinearSolverInterface.

virtual bool Ipopt::Ma57TSolverInterface::ProvidesInertia | ( |  | ) | const`[inline, virtual]`

Query whether inertia is computed by linear solver.

Returns true, if linear solver provides inertia.

Implements Ipopt::SparseSymLinearSolverInterface.

Definition at line 89 of file IpMa57TSolverInterface.hpp.

EMatrixFormat Ipopt::Ma57TSolverInterface::MatrixFormat | ( |  | ) | const`[inline, virtual]`

Query of requested matrix type that the linear solver understands.

Implements Ipopt::SparseSymLinearSolverInterface.

Definition at line 96 of file IpMa57TSolverInterface.hpp.

References Ipopt::SparseSymLinearSolverInterface::Triplet_Format.

static void Ipopt::Ma57TSolverInterface::RegisterOptions | ( | SmartPtr< RegisteredOptions > | roptions | ) | `[static]`

Methods for IpoptType.

void Ipopt::Ma57TSolverInterface::operator= | ( | const Ma57TSolverInterface & |  | ) | `[private]`

Overloaded Equals Operator.

ESymSolverStatus Ipopt::Ma57TSolverInterface::SymbolicFactorization | ( | const Index * | airn,
|  | const Index * | ajcn |
| ) |  |  | `[private]`

Call MA57AD and reserve memory for MA57 data.

Reserve memory for iw_ and ikeep_, call MA57AD to perform symbolic manipulations, and reserve all the remaining data memory

ESymSolverStatus Ipopt::Ma57TSolverInterface::Factorization | ( | const Index * | airn,
|  | const Index * | ajcn,
|  | bool | check_NegEVals,
|  | Index | numberOfNegEVals |
| ) |  |  | `[private]`

Call MA57BD to factorize the Matrix.

It is assumed that the first nonzeros_ element of a_ contain the values of the matrix to be factorized.

ESymSolverStatus Ipopt::Ma57TSolverInterface::Backsolve | ( | Index | nrhs,
|  | double * | rhs_vals |
| ) |  |  | `[private]`

Call MA57CD to do the backsolve.

## Member Data Documentation

Index Ipopt::Ma57TSolverInterface::dim_`[private]`

Number of rows and columns of the matrix.

Definition at line 126 of file IpMa57TSolverInterface.hpp.

Index Ipopt::Ma57TSolverInterface::nonzeros_`[private]`

Number of nonzeros of the matrix.

Definition at line 129 of file IpMa57TSolverInterface.hpp.

Index Ipopt::Ma57TSolverInterface::negevals_`[private]`

Number of negative eigenvalues.

Definition at line 135 of file IpMa57TSolverInterface.hpp.

bool Ipopt::Ma57TSolverInterface::initialized_`[private]`

Flag indicating if internal data is initialized.

For initialization, this object needs to have seen a matrix

Definition at line 142 of file IpMa57TSolverInterface.hpp.

bool Ipopt::Ma57TSolverInterface::pivtol_changed_`[private]`

Flag indicating if the matrix has to be refactorized because the pivot tolerance has been changed.

Definition at line 145 of file IpMa57TSolverInterface.hpp.

bool Ipopt::Ma57TSolverInterface::refactorize_`[private]`

Flag that is true if we just requested the values of the matrix again (SYMSOLVER_CALL_AGAIN) and have to factorize again.

Definition at line 149 of file IpMa57TSolverInterface.hpp.

Number Ipopt::Ma57TSolverInterface::pivtol_`[private]`

Pivol tolerance.

Definition at line 155 of file IpMa57TSolverInterface.hpp.

Number Ipopt::Ma57TSolverInterface::pivtolmax_`[private]`

Maximal pivot tolerance.

Definition at line 157 of file IpMa57TSolverInterface.hpp.

Number Ipopt::Ma57TSolverInterface::ma57_pre_alloc_`[private]`

Factor for estimating initial size of work arrays.

Definition at line 159 of file IpMa57TSolverInterface.hpp.

bool Ipopt::Ma57TSolverInterface::warm_start_same_structure_`[private]`

Flag indicating whether the TNLP with identical structure has already been solved before.

Definition at line 162 of file IpMa57TSolverInterface.hpp.

double Ipopt::Ma57TSolverInterface::wd_cntl_[5]`[private]`

Definition at line 169 of file IpMa57TSolverInterface.hpp.

ipfint Ipopt::Ma57TSolverInterface::wd_icntl_[20]`[private]`

Definition at line 170 of file IpMa57TSolverInterface.hpp.

ipfint Ipopt::Ma57TSolverInterface::wd_info_[40]`[private]`

Definition at line 172 of file IpMa57TSolverInterface.hpp.

double Ipopt::Ma57TSolverInterface::wd_rinfo_[20]`[private]`

Definition at line 173 of file IpMa57TSolverInterface.hpp.

ipfint Ipopt::Ma57TSolverInterface::wd_lkeep_`[private]`

Definition at line 175 of file IpMa57TSolverInterface.hpp.

ipfint* Ipopt::Ma57TSolverInterface::wd_keep_`[private]`

Definition at line 176 of file IpMa57TSolverInterface.hpp.

ipfint* Ipopt::Ma57TSolverInterface::wd_iwork_`[private]`

Definition at line 178 of file IpMa57TSolverInterface.hpp.

double* Ipopt::Ma57TSolverInterface::wd_fact_`[private]`

Definition at line 180 of file IpMa57TSolverInterface.hpp.

ipfint Ipopt::Ma57TSolverInterface::wd_lfact_`[private]`

Definition at line 181 of file IpMa57TSolverInterface.hpp.

ipfint* Ipopt::Ma57TSolverInterface::wd_ifact_`[private]`

Definition at line 182 of file IpMa57TSolverInterface.hpp.

ipfint Ipopt::Ma57TSolverInterface::wd_lifact_`[private]`

Definition at line 183 of file IpMa57TSolverInterface.hpp.

double* Ipopt::Ma57TSolverInterface::a_`[private]`

factor A of matrix

Definition at line 187 of file IpMa57TSolverInterface.hpp.

The documentation for this class was generated from the following file:

- /home/coin/SVN-release/Ipopt-3.2.1/Ipopt/src/Algorithm/LinearSolvers/IpMa57TSolverInterface.hpp